//Introduction:
//This program is usable for Toradex Oak Sensors. 
//You can use it for testing data transfer between OAK Sensor and Colibri Modul.
//Following sensors are supported with this program:
//Oak RH	-> ProductID = 1
//Oak P		-> ProductID = 2
//Oak LUX	-> ProductID = 3
//Oak MOVE	-> ProductID = 6
//Oak G		-> ProductID = 10
//Oak MAGR	-> ProductID = 11


//include headerfiles
#include <windows.h> 
#include "oakhid.h"
#include "stdio.h"
#include <stdlib.h>
#include <Winuser.h>


#define SETFNAME(name)	const TCHAR * const pszFname = (name)
#define ZONE_FUNCTION	1
#define ZONE_ERROR		1

//global initialisation
DWORD	g_dwProductID;

//start Win32-Application
int WINAPI WinMain(	HINSTANCE hInstance,
					HINSTANCE hPrevInstance,
					LPTSTR    lpCmdLine,
					int       nCmdShow)

					

{
 	//init
	int stasto, SensData0, SensData1, SensData2, SensData3;

	SHORT GetKeyState(int nVirtKey); 

	HANDLE hDeviceAccessSens;

	DWORD	dwBytesSens;	
	DWORD	dwBytes;

	WORD	pReportSens[4];
		
	BYTE	pbReport[128];

	//set pszFname
	SETFNAME(_T("OakMonitor::OakInfoGraphThreadProc"));


	//output title
	printf("TORADEX OAK USB Sensor Tester\n");
	printf("-----------------------------\n\n\n");

	
	
	//READ SENSOR DATA

	//create file access
	hDeviceAccessSens = CreateFile(_T("OAK1:"),GENERIC_READ,0,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
	if(hDeviceAccessSens == INVALID_HANDLE_VALUE) //TRUE = Error
	{
		printf("NO sensor is connected!");
		Sleep (2000);
		goto EXIT;
	}

	//read Product ID Sensor
	if(!DeviceIoControl(hDeviceAccessSens,IOCTL_OAK_GET_PRODUCT_ID,NULL,0,&g_dwProductID,4,&dwBytes,NULL)) 
	{
		goto EXIT;
	}

	
	

//START WRITE OUTPUT
	
	//Connection-Check with ProductIDs
	if ((g_dwProductID == 1) || (g_dwProductID == 2) || (g_dwProductID == 3) || (g_dwProductID == 6) || (g_dwProductID == 10) || (g_dwProductID == 11))
	{
		printf("Sensor is connected!\n");
	}
	else //no or wrong sensor is connected...
	{
		printf("NO or WRONG sensor is connected!");
		Sleep (2000);
		return 0;
	}


MENU:
	printf("\n\n[1] START data output.");
	printf("\n[2] END program.\t");
	scanf("%d", &stasto);	//input menu-choise

	//end menu


	//start data output

	switch (stasto)
	{
		
		//write sensor data
		case 1:
		{ 
			FILE* fp;	//pointer for "fp"
			fp = fopen("sensor_output.txt","w");	//create txt-file or overwrite, if it already existent

			if ((g_dwProductID == 3) || (g_dwProductID == 6))	//output for sensors with a report-lenght == 3 Bytes
			{
				printf("\n\n\nStart sensor data output...");	//write in cmd-console
				printf("\n[ESC] stop output.\n\n");
				printf("Frame Number\t");
				printf("Byte1\n\n");

				fprintf(fp, "Frame Number\t");					//write in txt-file
				fprintf(fp, "Byte1\n\n");
			}

			if ((g_dwProductID == 1) || (g_dwProductID == 2))	//output for sensors with a report-lenght == 4 Bytes
			{	
				printf("\n\n\nStart sensor data output...");	//write in cmd-console
				printf("\n[ESC] stop output.\n\n");
				printf("Frame Number\t");
				printf("Byte1\t");
				printf("Byte2\n\n");

				fprintf(fp, "Frame Number\t");					//write in txt-file
				fprintf(fp, "Byte1\t");
				fprintf(fp, "Byte2\n\n");
			}

			if ((g_dwProductID == 10) || (g_dwProductID == 11))	//output for sensors with a report-lenght == 5 Bytes
			{
				printf("\n\n\nStart sensor data output...");	//write in cmd-console
				printf("\n[ESC] stop output.\n\n");
				printf("Frame Number\t");
				printf("Byte1\t");
				printf("Byte2\t");
				printf("Byte3\n\n");

				fprintf(fp, "Frame Number\t");					//write in txt-file
				fprintf(fp, "Byte1\t");
				fprintf(fp, "Byte2\t");
				fprintf(fp, "Byte3\n\n");	
			}


			
			while(1)
			{		
				//read "interrupt in report"
				DeviceIoControl(hDeviceAccessSens,IOCTL_OAK_GET_INPUT_REPORT,NULL,0,&pbReport,128,&dwBytesSens,NULL);
				
				//remove ReportID from HID-protocol
				memcpy(pReportSens,pbReport+1,dwBytesSens-1);	

				SensData0 = pReportSens[0];
				SensData1 = pReportSens[1];
				SensData2 = pReportSens[2];
				SensData3 = pReportSens[3];


				if ((g_dwProductID == 3) || (g_dwProductID == 6))	//data-output for sensors with a report-lenght == 3 Bytes
				{
					printf("%i\t\t", SensData0);		//write in cmd-console
					printf("%i\n", SensData1);
					
					fprintf(fp, "%i\t\t", SensData0);	//write in txt-file
					fprintf(fp, "%i\n", SensData1);
				}

				if ((g_dwProductID == 1) || (g_dwProductID == 2))	//data-output for sensors with a report-lenght == 4 Bytes
				{	
					printf("%i\t\t", SensData0);		//write in cmd-console
					printf("%i\t", SensData1);
					printf("%i\n", SensData2);

					fprintf(fp, "%i\t\t", SensData0);	//write in txt-file
					fprintf(fp, "%i\t", SensData1);
					fprintf(fp, "%i\n", SensData2);
				}

				if ((g_dwProductID == 10) || (g_dwProductID == 11))	//data-output for sensors with a report-lenght == 5 Bytes
				{
					printf("%i\t\t", SensData0);		//write in cmd-console
					printf("%i\t", SensData1);
					printf("%i\t", SensData2);
					printf("%i\n", SensData3);

					fprintf(fp, "%i\t\t", SensData0);	//write in txt-file
					fprintf(fp, "%i\t", SensData1);
					fprintf(fp, "%i\t", SensData2);
					fprintf(fp, "%i\n", SensData3);
				}


				Sleep(1000);	//clock frequency for output (1s)


				if(GetAsyncKeyState(VK_ESCAPE))		//function for the output-interrupt
				{
					printf("\nOutput stopped...\n");
					
					fclose(fp); //close txt-file
					goto MENU;	//back to menu

					break;
					getchar();
				} 

			}
		}

		case 2:
		{
			printf("\n\nProgramm will close...");	//close programm
			Sleep (1000);
			return 0;
		}
 
				
	}
	//end data output



//start program-end

	EXIT:
	{
		//close sensor
		CloseHandle(hDeviceAccessSens);

		return 0;
	}

}